#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <pslib.h>
#include <psmodules.h>
#include <ppStats.h>

#include "ppStack.h"

psString ppStackVersion(void)
{
#ifndef PPSTACK_VERSION
#error "PPSTACK_VERSION is not set"
#endif
#ifndef PPSTACK_BRANCH
#error "PPSTACK_BRANCH is not set"
#endif
    return psStringCopy(PPSTACK_BRANCH "@" PPSTACK_VERSION);
}

psString ppStackSource(void)
{
#ifndef PPSTACK_SOURCE
#error "PPSTACK_SOURCE is not set"
#endif
    return psStringCopy(PPSTACK_SOURCE);
}

psString ppStackVersionLong(void)
{
    psString version = ppStackVersion();  // Version, to return
    psString source = ppStackSource();    // Source

    psStringPrepend(&version, "ppStack ");
    psStringAppend(&version, " from %s, built %s, %s", source, __DATE__, __TIME__);
    psFree(source);

#ifdef __OPTIMIZE__
    psStringAppend(&version, " optimised");
#else
    psStringAppend(&version, " unoptimised");
#endif

    return version;
};


void ppStackVersionMetadata(psMetadata *metadata)
{
    PS_ASSERT_METADATA_NON_NULL(metadata,);

    psString pslib = psLibVersionLong();// psLib version
    psString psmodules = psModulesVersionLong(); // psModules version
    psString ppStats = ppStatsVersionLong(); // ppStats version
    psString ppStack = ppStackVersionLong(); // ppStack version

    psTime *time = psTimeGetNow(PS_TIME_TAI); // The time now
    psString timeString = psTimeToISO(time); // The time in an ISO string
    psFree(time);
    psString head = NULL;               // Head string
    psStringAppend(&head, "ppStack processing at %s. Component information:", timeString);
    psFree(timeString);

    psMetadataAddStr(metadata, PS_LIST_TAIL, "HISTORY", PS_META_DUPLICATE_OK, "", head);
    psMetadataAddStr(metadata, PS_LIST_TAIL, "HISTORY", PS_META_DUPLICATE_OK, "", pslib);
    psMetadataAddStr(metadata, PS_LIST_TAIL, "HISTORY", PS_META_DUPLICATE_OK, "", psmodules);
    psMetadataAddStr(metadata, PS_LIST_TAIL, "HISTORY", PS_META_DUPLICATE_OK, "", ppStats);
    psMetadataAddStr(metadata, PS_LIST_TAIL, "HISTORY", PS_META_DUPLICATE_OK, "", ppStack);

    psFree(head);
    psFree(pslib);
    psFree(psmodules);
    psFree(ppStats);
    psFree(ppStack);

    return;
}
